﻿' ================================================================================
' Developed by Black Falcon Software, Inc.
' Copyright 2017
' License - MIT (Open Source)
' 
' Restrictions: Module cannot be sold for profit in "As Is" state
'               Module can only be sold commercially as part of a larger product
' ================================================================================


Imports System
Imports System.IO
Imports System.Xml
Imports System.Data
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Configuration

Imports FirebirdSql.Data
Imports FirebirdSql.Data.FirebirdClient


Public Class MainWindow

    #Region "Class Level Declarations"

        Private cboolBypassFbSqlParameterNamesListSelectionChangedEvent       As Boolean = False
        Private cboolBypassFbSqlParameterDirectionsListSelectionChangedEvent  As Boolean = False
        Private cboolBypassTransactionActionsListSelectionChangedEvent        As Boolean = False  

        Private ciFbSqlActionId                                               As Integer = 0
        Private ciSelectedFbSqlActionId                                       As Integer = 0
        Private csProcess                                                     As String = ""
        Private csTransactSupportProcess                                      As String = ""
        Private csXmlString                                                   As String = ""

        Private coFbSqlDirectionsArrayList                                    As New ArrayList()
        Private coFbSqlDataTypesArrayList                                     As New ArrayList()
        Private coFbSqlParametersArrayList                                    As New ArrayList()
        Private coFbSqlActionsArrayList                                       As New ArrayList()

        Private coFbSqlConnection                                             As FbConnection
        Private coFbSqlTransaction                                            As FbTransaction

    #End Region


    #Region "Window Loaded Event"

        Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles MyBase.Loaded

            ' ---
            ' process necessary initializations
            ' ---
            Process_MainWindow_Loaded_Event()
        End Sub

    #End Region


    #Region "Window Support Events"

        Private Sub MainWindow_MouseDown(sender As Object, e As MouseButtonEventArgs) Handles MyBase.MouseDown

             Process_MainWindow_MouseDown_Event(e)
        End Sub


        Private Sub btnMinimizeScreen_Click(sender As Object, e As RoutedEventArgs) Handles btnMinimizeScreen.Click

            Process_btnMinimizeScreen_Click()
        End Sub

    #End Region


    #Region "Menu Events"

        Private Sub mnuDataReader_Click(sender As Object, e As RoutedEventArgs) Handles mnuDataReader.Click

            Process_mnuDataReader_Click_Event()
       End Sub


        Private Sub mnuDataSet_Click(sender As Object, e As RoutedEventArgs) Handles mnuDataSet.Click

            Process_mnuDataSet_Click_Event()
        End Sub


        Private Sub mnuXml_Click(sender As Object, e As RoutedEventArgs) Handles mnuXml.Click

            Process_mnuXml_Click_Event()
        End Sub


        Private Sub mnuScalar_Click(sender As Object, e As RoutedEventArgs) Handles mnuScalar.Click

            Process_mnuScalar_Click_Event()
        End Sub


        Private Sub mnuUpdate_Click(sender As Object, e As RoutedEventArgs) Handles mnuUpdate.Click

            Process_mnuUpdate_Click_Event()
        End Sub


        Private Sub mnuMultiActionTransaction_Click(sender As Object, e As RoutedEventArgs) Handles mnuMultiActionTransaction.Click

            Process_mnuMultiActionTransaction_Click_Event()
        End Sub


        Private Sub mnuClear_Click(sender As Object, e As RoutedEventArgs) Handles mnuClear.Click

            Process_mnuClear_Click_Event()
        End Sub


        Private Sub mnuHelp_Click(sender As Object, e As RoutedEventArgs) Handles mnuHelp.Click

            Process_mnuHelp_Click_Event()
        End Sub


        Private Sub mnuExit_Click(sender As Object, e As RoutedEventArgs) Handles mnuExit.Click

            Process_mnuExit_Click_Event()
        End Sub

    #End Region


    #Region "Button Events"

        #Region "Execute SQL"

            Private Sub btnExecuteSQL_Click(sender As Object, e As RoutedEventArgs) Handles btnExecuteSQL.Click

                Process_btnExecuteSQL_Click_Event(e)
            End Sub

        #End Region


        #Region "Query\Action Parameter Support"

            Private Sub btnSaveFbSqlParameter_Click(sender As Object, e As RoutedEventArgs) Handles btnSaveFbSqlParameter.Click

                Process_btnSaveFbSqlParameter_Click_Event()
            End Sub


            Private Sub btnNewFbSqlParameter_Click(sender As Object, e As RoutedEventArgs) Handles btnNewFbSqlParameter.Click

                Process_btnNewFbSqlParameter_Click_Event()
            End Sub


            Private Sub btnDeleteFbSqlParameter_Click(sender As Object, e As RoutedEventArgs) Handles btnDeleteFbSqlParameter.Click

                Process_btnDeleteFbSqlParameter_Click_Event()
            End Sub


            Private Sub btnDeleteAllFbSqlParameters_Click(sender As Object, e As RoutedEventArgs) Handles btnDeleteAllFbSqlParameters.Click

                Process_btnDeleteAllFbSqlParameters_Click_Event()
            End Sub

        #End Region


        #Region "Transaction Actions Support"

            Private Sub btnSaveTransactionAction_Click(sender As Object, e As RoutedEventArgs) Handles btnSaveTransactionAction.Click

                Process_btnSaveTransactionAction_Click_Event()
            End Sub


            Private Sub btnEditTransactionAction_Click(sender As Object, e As RoutedEventArgs) Handles btnEditTransactionAction.Click

                Process_btnEditTransactionAction_Click_Event()
            End Sub


            Private Sub btnDeleteTransactionAction_Click(sender As Object, e As RoutedEventArgs) Handles btnDeleteTransactionAction.Click

                Process_btnDeleteTransactionAction_Click_Event()
            End Sub


            Private Sub btnDeleteAllTransactionActions_Click(sender As Object, e As RoutedEventArgs) Handles btnDeleteAllTransactionActions.Click

                Process_btnDeleteAllTransactionActions_Click_Event()
            End Sub

        #End Region


        #Region "Expanded XML View"

            Private Sub btnViewXml_Click(sender As Object , e As RoutedEventArgs) Handles btnViewXml.Click

                Dim loViewXml  As New ViewXml(csXmlString)


                loViewXml.Owner = DirectCast(MainWindow, Window)
                loViewXml.ShowDialog()        
            End Sub

        #End Region

    #End Region


    #Region "DropDownListBox Events"

        Private Sub lstFbSqlParameterNames_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles lstFbSqlParameterNames.SelectionChanged

            Process_lstFbSqlParameterNames_SelectionChanged_Event()
        End Sub


        Private Sub lstFbSqlParameterDirections_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles lstFbSqlParameterDirections.SelectionChanged

            Process_lstFbSqlParameterDirections_SelectionChanged_Event()
        End Sub


        Private Sub lstFbSqlDataTypes_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles lstFbSqlDataTypes.SelectionChanged

            Process_lstFbSqlDataTypes_SelectionChanged_Event()
        End Sub


        Private Sub lstSavedTransactionActions_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles lstSavedTransactionActions.SelectionChanged

            Process_lstSavedTransactionActions_SelectionChanged_Event()
        End Sub

    #End Region


    #Region "Process Events"

        #Region "Window Load Event"

            Private Sub Process_MainWindow_Loaded_Event()

                Load_RequiredClassLevelCollections()
                Load_FbSqlParameterDirectionsListBox()
                Load_FbSqlDataTypesListBox()

                Disable_AllControls()
            End Sub

        #End Region


        #Region "Window Support Events"
    
            Private Sub Process_MainWindow_MouseDown_Event(e As MouseButtonEventArgs)

                If (e.ChangedButton = MouseButton.Left) Then
                    DragMove()
                End If
            End Sub


            Private Sub Process_btnMinimizeScreen_Click()

                Dim loWindow  As Window = Me


                loWindow.WindowState = WindowState.Minimized
            End Sub

        #End Region


        #Region "Menu Events"

            Private Sub Process_mnuDataReader_Click_Event()

                Clear_AllClassLevelDeclarations()
                Clear_AllControls()

                csProcess = "DataReader"    

                lblSelectedProcess.Content = "Query DataReader"
                lblSelectedProcess.Visibility = System.Windows.Visibility.Visible

                Disable_AllControls()
                Enable_DataReaderControls()
            End Sub


            Private Sub Process_mnuDataSet_Click_Event()

                Clear_AllClassLevelDeclarations()
                Clear_AllControls()

                csProcess = "DataSet"    

                lblSelectedProcess.Content = "Query DataSet"
                lblSelectedProcess.Visibility = System.Windows.Visibility.Visible
      
                Disable_AllControls()
                Enable_DataSetControls()
            End Sub


            Private Sub Process_mnuXml_Click_Event()

                Clear_AllClassLevelDeclarations()
                Clear_AllControls()

                csProcess = "Xml"    

                lblSelectedProcess.Content = "Query Xml"
                lblSelectedProcess.Visibility = System.Windows.Visibility.Visible

                Disable_AllControls()
                Enable_XmlControls()
            End Sub


            Private Sub Process_mnuScalar_Click_Event()

                Clear_AllClassLevelDeclarations()
                Clear_AllControls()

                csProcess = "Scalar"    

                lblSelectedProcess.Content = "Query Scalar"
                lblSelectedProcess.Visibility = System.Windows.Visibility.Visible

                Disable_AllControls()
                Enable_ScalarControls()
            End Sub


            Private Sub Process_mnuUpdate_Click_Event()

                Clear_AllClassLevelDeclarations()
                Clear_AllControls()

                csProcess = "NonQuery"    

                lblSelectedProcess.Content = "Action NonQuery"
                lblSelectedProcess.Visibility = System.Windows.Visibility.Visible

                Disable_AllControls()
                Enable_UpdateControls()
            End Sub


            Private Sub Process_mnuMultiActionTransaction_Click_Event()

                Clear_AllClassLevelDeclarations()
                Clear_AllControls()

                csProcess = "MultiActionTransaction"    

                lblSelectedProcess.Content = "Multi-Action Transactional Update"
                lblSelectedProcess.Visibility = System.Windows.Visibility.Visible

                Disable_AllControls()
                Enable_MultiActionTransactionControls()
            End Sub


            Private Sub Process_mnuClear_Click_Event()

                Clear_AllClassLevelDeclarations()
                Clear_AllControls()

                Disable_AllControls()
            End Sub


            Private Sub Process_mnuHelp_Click_Event()

                Process.Start("FBHelper4.5.chm")
            End Sub


            Private Sub Process_mnuExit_Click_Event()

                Application.Current.Shutdown()
            End Sub

         #End Region


         #Region "Button Events"

            #Region "Execute SQL"

                Private Sub Process_btnExecuteSQL_Click_Event(e As RoutedEventArgs)

                    Clear_Message()


                    '---
                    ' validate execute requirements
                    '---
                    If (Not Is_ValidateExecuteRequirementsOK(e)) Then
                        Return 
                    End If

                    '---
                    'process execute
                    '---
                    Cursor = Cursors.Wait
            
                        Clear_ReturnedDataResultsDatagrid()
                        Clear_ReturnedParameterValuesListview()

                        Select Case (csProcess)
                            Case "DataReader":
                                Execute_DataReader()

                            Case "DataSet":
                                Execute_DataSet()

                            Case "Xml":
                                Execute_Xml()

                            Case "Scalar":
                                Execute_Scalar()

                            Case "NonQuery":
                                Execute_NonQuery()

                            Case "MultiActionTransaction":
                                Execute_MultiActionTransaction()
                        End Select          

                    Cursor = Cursors.Arrow
                End Sub

            #End Region


            #Region "Query\Action Parameter Support"

                Private Sub Process_btnSaveFbSqlParameter_Click_Event()

                    Dim lsSuccessMessage                 As String = ""

                    Dim loFbSqlHelperParameterStructure  As New BlackFalconAB.Firebird.FbSqlHelperParameterStructure()


                    Clear_Message()


                    If (Not Validate_FbSqlParameterEntries(loFbSqlHelperParameterStructure, lsSuccessMessage)) Then
                        Return
                    End If


                    Load_FbSqlParameterNamesListBox(loFbSqlHelperParameterStructure)
                    Load_FbSqlParameterArrayList(loFbSqlHelperParameterStructure)

                    Clear_ParameterEntries()

                    Display_Message("I", lsSuccessMessage) 
                End Sub


                Private Sub Process_btnNewFbSqlParameter_Click_Event()

                    Clear_Message()
                    Clear_ParameterEntries()
                End Sub


                Private sub Process_btnDeleteFbSqlParameter_Click_Event()

                    Clear_Message()


                    If (lstFbSqlParameterNames.Items.Count > 0) Then
                        If (lstFbSqlParameterNames.SelectedIndex = 0) Then
                            Display_Message("E", "No parmeter selected for delete...") 
                            Return
                        End If
                    Else
                        Display_Message("E", "No parameters available for delete !") 
                        Return
                    End If

                    Delete_FbSqlParameterFromListBox(txtFbSqlParameterName.Text.Trim())
                    Delete_FbSqlParameterFromArrayList(txtFbSqlParameterName.Text.Trim())

                    Clear_ParameterEntries()

                    Display_Message("I", "Parameter successfully deleted...") 
                End sub


                Private Sub Process_btnDeleteAllFbSqlParameters_Click_Event()

                    Clear_Message()


                    Delete_AllFbSqlParameterFromListBox()
                    Delete_AllFbSqlParametersFromArrayList()

                    Clear_ParameterEntries()

                    Display_Message("I", "All Parameters successfully deleted...") 
                End Sub

            #End Region


            #Region "Transaction Actions Support"

                Private Sub Process_btnSaveTransactionAction_Click_Event()

                    Dim loFbSQLHelperActionStructure  As New BlackFalconAB.Firebird.FbSqlHelperActionStructure()


                    Clear_Message()


                    If (ciSelectedFbSqlActionId > 0) Then
                        loFbSQLHelperActionStructure.FBSQL_ACTION_ID = ciSelectedFbSqlActionId
                    End If

                    loFbSQLHelperActionStructure.FBSQL_ACTION = txtFbSqlScript.Text.Trim()
                    loFbSQLHelperActionStructure.FBSQL_PARAMETERS = coFbSqlParametersArrayList.Clone()

                    Load_FbSqlActionsArrayList(loFbSQLHelperActionStructure)
                    Load_SavedTransactionActionEntriesListbox()

                    Clear_ParameterArrayList()
                    Delete_AllFbSqlParameterFromListBox()
                    Clear_FbSqlAndParameterEntries()

                    Display_Message("I", "Transaction action successfully saved...") 
                End Sub


                Private Sub Process_btnEditTransactionAction_Click_Event()

                    Dim liIndex                          As Integer = 0
            
                    Dim loComboBoxItem                   As ComboBoxItem

                    Dim loFbSqlHelperParameterStructure  As New BlackFalconAB.Firebird.FbSqlHelperParameterStructure()
                    Dim loFbSqlHelperActionStructure     As New BlackFalconAB.Firebird.FbSqlHelperActionStructure()


                    Clear_Message()


                    loComboBoxItem = lstSavedTransactionActions.SelectedItem

                    If (lstSavedTransactionActions.Items.Count = 0) Then
                        Display_Message("E", "No actions have been saved !") 
                        Return
                    End If

                    If (loComboBoxItem.Tag.Equals("0")) Then
                        Display_Message("E", "No action was selected !") 
                        Return
                    End If


                    liIndex = lstSavedTransactionActions.SelectedIndex - 1

                    loFbSqlHelperActionStructure = DirectCast(coFbSqlActionsArrayList(liIndex), BlackFalconAB.Firebird.FbSqlHelperActionStructure)
            
                    ciSelectedFbSqlActionId = loFbSqlHelperActionStructure.FBSQL_ACTION_ID


                    ' ---
                    ' load sql text & parameter array list (if any parameters)
                    ' ---
                    txtFbSqlScript.Text = loFbSqlHelperActionStructure.FBSQL_ACTION

                    If (loFbSqlHelperActionStructure.FBSQL_PARAMETERS.Count > 0) Then
                        coFbSqlParametersArrayList = loFbSqlHelperActionStructure.FBSQL_PARAMETERS.Clone()

                        Clear_FbSqlParameterNamesListBox()
                        Load_FbSqlParameterNamesListBoxWithAllNames(coFbSqlParametersArrayList)
                        Load_ParameterEntries(0)
                    End If
                End Sub


                Private Sub Process_btnDeleteTransactionAction_Click_Event()

                    Dim liIndex         As Integer = 0
            
                    Dim loComboBoxItem  As ComboBoxItem


                    Clear_Message()


                    If (lstSavedTransactionActions.Items.Count > 0) Then
                        loComboBoxItem = lstSavedTransactionActions.SelectedItem

                        If (loComboBoxItem.Tag.Equals("0")) Then
                            Display_Message("E", "No action was selected !") 
                            Return
                        End If
                    Else
                        Display_Message("E", "No actions available for delete !") 
                        Return
                    End If


                    liIndex = Convert.ToInt32(loComboBoxItem.Tag.ToString().Trim())

                    Delete_TransactionActionFromListBox(liIndex)
                    Delete_TransactionActionFromArrayList(liIndex)
                    Clear_FbSqlAndParameterEntries()
                    Clear_ReturnedDataResultsDatagrid()
                    Clear_ReturnedParameterValuesListview()

                    Display_Message("I", "Transaction action successfully deleted...") 
                End Sub


                Private Sub Process_btnDeleteAllTransactionActions_Click_Event()

                    Clear_Message()


                    If (lstSavedTransactionActions.Items.Count = 0) Then
                        Display_Message("E", "No actions available for delete !") 
                        Return
                    End If


                    Delete_AllTransactionActionsFromListBox()
                    Delete_AllTransactionActionsFromArrayList()
                    Clear_FbSqlAndParameterEntries()
                    Clear_ReturnedDataResultsDatagrid()
                    Clear_ReturnedParameterValuesListview()

                    Display_Message("I", "All transactions action successfully deleted...") 
                End Sub

            #End Region

        #End Region


         #Region "DropDownListBox Events"

            Private Sub Process_lstFbSqlParameterNames_SelectionChanged_Event()

                If (cboolBypassFbSqlParameterNamesListSelectionChangedEvent) Then
                    Return
                End If


                If (lstFbSqlParameterNames.SelectedIndex > 0) Then
                    Load_ParameterEntries(lstFbSqlParameterNames.SelectedIndex)
                Else
                    Clear_ParameterEntries()
                End If
            End Sub


            Private Sub Process_lstFbSqlParameterDirections_SelectionChanged_Event()

                Dim loFbSqlParameterDirectionComboBoxItem  As ComboBoxItem


                loFbSqlParameterDirectionComboBoxItem = lstFbSqlParameterDirections.SelectedItem

                ' ---
                ' parameter direction = "Input" enable the value parameter entry field
                ' parameter direction = "Output" disable the value parameter entry field
                ' ---
                If (loFbSqlParameterDirectionComboBoxItem.Content.Equals("Output")) Then
                    txtFbSqlParameterValue.IsEnabled = False
                Else
                    txtFbSqlParameterValue.IsEnabled = True
                End If
            End Sub


            Private Sub Process_lstFbSqlDataTypes_SelectionChanged_Event()

                Dim loFbSqlDataTypeComboBoxItem  As ComboBoxItem


                loFbSqlDataTypeComboBoxItem = lstFbSqlDataTypes.SelectedItem

                If (Is_ParameterCategoryString(Convert.ToInt32(loFbSqlDataTypeComboBoxItem.Tag.ToString().Trim()))) Then
                    txtFbSqlParameterSize.IsEnabled = True
                Else
                    txtFbSqlParameterSize.IsEnabled = False
                End If

                txtFbSqlParameterSize.Text = ""
            End Sub


            Private Sub Process_lstSavedTransactionActions_SelectionChanged_Event()

            End Sub

         #End Region

    #End Region


    #Region "Private Methods - Execute Methods"

        Private Sub Execute_DataReader()

            Dim lsConnectionString  As String = ""
            Dim lsQuery             As String = ""

            Dim loDataTable         As DataTable
            Dim loFbSqlDataReader   As FbDataReader

            Dim loFbSqlHelper       As New BlackFalconAB.Firebird.FbSqlHelper()
      
      
            Clear_Message()


            ' ---
            ' get connection string, sql script, & parameters
            ' ---
            If (txtFbSqlScript.Text.Trim.Length = 0) Then
                Display_Message("E", "No query\action was entered !") 
                Return
            End If
      
            lsConnectionString = txtConnectionString.Text.Trim()
            lsQuery = txtFbSqlScript.Text.Trim()


            ' ---
            ' perform query and return a data-reader
            ' ---
            Try
                If (coFbSqlParametersArrayList.Count = 0) Then
                    loFbSqlDataReader = loFbSqlHelper.ExecuteDataReader(lsConnectionString, lsQuery)
                Else
                    loFbSqlDataReader = loFbSqlHelper.ExecuteDataReader(lsConnectionString, lsQuery, coFbSqlParametersArrayList)
                End If  


                ' display data
                loDataTable = New DataTable()

                If (loFbSqlDataReader.HasRows) Then
                    loDataTable.Load(loFbSqlDataReader)
                    dgReturnedDataResults.ItemsSource = loDataTable.DefaultView
                Else
                    Display_Message("I", "No data returned from query; but output parameters may have data.") 
                End If

                loFbSqlDataReader.Close()


                ' display any output parameter data  (Firebird DataReader does not support output parameters)
                'If (coMySqlParametersArrayList.Count > 0) Then
                '    Load_OutputParameterValues(True, coMySqlParametersArrayList)
                'End If  

                Display_Message("I", "Query completed successfully.") 
            Catch loException As Exception
                Display_Message("E", loException.Message) 
            End Try
        End Sub


        Private Sub Execute_DataSet()

            Dim liParameterCnt      As Integer = 0
            Dim lsConnectionString  As String = ""
            Dim lsQuery             As String = ""

            Dim loDataSet           As DataSet

            Dim loFbSqlHelper       As New BlackFalconAB.Firebird.FbSqlHelper()


            Clear_Message()


            ' ---
            ' get connection string, sql script, & parameters
            ' ---
            If (txtFbSqlScript.Text.Trim.Length = 0) Then
                Display_Message("E", "No query\action was entered !") 
                Return
            End If
      
            lsConnectionString = txtConnectionString.Text.Trim()
            lsQuery = txtFbSqlScript.Text.Trim()

      
            ' ---
            ' perform query and return a dataset
            ' ---
            Try
                If (coFbSqlParametersArrayList.Count = 0) Then
                    loDataSet = loFbSqlHelper.ExecuteDataSet(lsConnectionString, lsQuery)
                Else
                    loDataSet = loFbSqlHelper.ExecuteDataSet(lsConnectionString, lsQuery, coFbSqlParametersArrayList)
                End If  


                ' display data
                If (loDataSet.Tables.Count > 0) Then
                    dgReturnedDataResults.ItemsSource = loDataSet.Tables(0).DefaultView()
                Else
                    Display_Message("I", "No data returned from query; but output parameters may have data.") 
                End If

                ' display any output parameter data
                If (coFbSqlParametersArrayList.Count > 0) Then
                    Load_OutputParameterValues(True, coFbSqlParametersArrayList)
                End If  

                Display_Message("I", "Query completed successfully.") 
            Catch loException As Exception
                Display_Message("E", loException.Message) 
            End Try
        End Sub


        Private Sub Execute_Xml()

            Dim liParameterCnt      As Integer = 0
            Dim lsConnectionString  As String = ""
            Dim lsQuery             As String = ""
            
            Dim loXMLObject         As Object = ""

            Dim loDataSet           As New DataSet()

            Dim loStringReader      As StringReader

            Dim loFbSqlHelper       As New BlackFalconAB.Firebird.FbSqlHelper()


            Clear_Message()


            ' ---
            ' get connection string, sql script, & parameters
            ' ---
            If (txtFbSqlScript.Text.Trim.Length = 0) Then
                Display_Message("E", "No query\action was entered !") 
                Return
            End If
      
            lsConnectionString = txtConnectionString.Text.Trim()
            lsQuery = txtFbSqlScript.Text.Trim()
      

            ' ---
            ' perform query and return xml data
            ' ---
            Try
                If (coFbSqlParametersArrayList.Count = 0) Then
                    loXMLObject = loFbSqlHelper.ExecuteXml(lsConnectionString, lsQuery)
                Else
                    loXMLObject = loFbSqlHelper.ExecuteXml(lsConnectionString, lsQuery, coFbSqlParametersArrayList)
                End If  


                ' display data
                If (String.Compare(loXMLObject.ToString().Trim(), "<NewDataSet />") <> 0) Then
                    csXmlString = loXMLObject.ToString().Trim()

                    loStringReader = New StringReader(loXMLObject.ToString().Trim())
                    loDataSet.ReadXml(loStringReader)

                    dgReturnedDataResults.ItemsSource = loDataSet.Tables(0).DefaultView()
                Else
                  Display_Message("I", "No data returned from query; but output parameters may have data.") 
                End If

                ' display any output parameter data
                If (coFbSqlParametersArrayList.Count > 0) Then
                    Load_OutputParameterValues(True, coFbSqlParametersArrayList)
                End If  

                Display_Message("I", "Query completed successfully.") 
            Catch loException As Exception
                Display_Message("E", loException.Message) 
            End Try
        End Sub


        Private Sub Execute_Scalar()

            Dim liParameterCnt      As Integer = 0
            Dim lsConnectionString  As String = ""
            Dim lsQuery             As String = ""
            
            Dim loScalarObject      As Object

            Dim loDataSet           As New DataSet()

            Dim loDataColumn        As DataColumn
            Dim loDataRow           As DataRow
            Dim loDataTable         As New DataTable()
            Dim loFbSqlHelper       As New BlackFalconAB.Firebird.FbSqlHelper()


            Clear_Message()


            ' ---
            ' get connection string, sql script, & parameters
            ' ---
            If (txtFbSqlScript.Text.Trim.Length = 0) Then
                Display_Message("E", "No query\action was entered !") 
                Return
            End If
      
            lsConnectionString = txtConnectionString.Text.Trim()
            lsQuery = txtFbSqlScript.Text.Trim()


            ' ---
            ' perform query and return scalar data
            ' ---
            Try
                If (coFbSqlParametersArrayList.Count = 0) Then
                    loScalarObject = loFbSqlHelper.ExecuteScalar(lsConnectionString, lsQuery)
                Else
                    loScalarObject = loFbSqlHelper.ExecuteScalar(lsConnectionString, lsQuery, coFbSqlParametersArrayList)
                End If  


                ' display data
                If (Not loScalarObject Is Nothing) Then
                  loDataColumn = New DataColumn("SCALAR VALUE")
                  loDataColumn.DataType = System.Type.GetType("System.String")
                  loDataColumn.ReadOnly = True

                  loDataTable.Columns.Add(loDataColumn)

                  loDataRow = loDataTable.NewRow()
                  loDataRow(0) = loScalarObject.ToString().Trim()

                  loDataTable.Rows.Add(loDataRow)

                  loDataSet.Tables.Add(loDataTable)  

                  dgReturnedDataResults.ItemsSource = loDataSet.Tables(0).DefaultView()
                Else
                  Display_Message("I", "No data returned from query; but output parameters may have data.") 
                End If

                ' display any output parameter data
                If (coFbSqlParametersArrayList.Count > 0) Then
                    Load_OutputParameterValues(True, coFbSqlParametersArrayList)
                End If  

                Display_Message("I", "Query completed successfully.") 
            Catch loException As Exception
                Display_Message("E", loException.Message) 
            End Try
        End Sub


        Private Sub Execute_NonQuery()

            Dim liRecordsAffected   As Integer = 0
            Dim liParameterCnt      As Integer = 0
            Dim lsConnectionString  As String = ""
            Dim lsAction            As String = ""
            
            Dim loDataSet           As New DataSet()

            Dim loDataColumn        As DataColumn
            Dim loDataRow           As DataRow
            Dim loDataTable         As New DataTable()
            Dim loFbSqlHelper       As New BlackFalconAB.Firebird.FbSqlHelper()


            Clear_Message()


            ' ---
            ' get connection string, sql script, & parameters
            ' ---
            If (txtFbSqlScript.Text.Trim.Length = 0) Then
                Display_Message("E", "No query\action was entered !") 
                Return
            End If
      
            lsConnectionString = txtConnectionString.Text.Trim()
            lsAction = txtFbSqlScript.Text.Trim()


            ' ---
            ' perform action and return any output parameter data
            ' ---
            Try
                If (coFbSqlParametersArrayList.Count = 0) Then
                    liRecordsAffected = loFbSqlHelper.ExecuteNonQuery(lsConnectionString, lsAction)
                Else
                    liRecordsAffected = loFbSqlHelper.ExecuteNonQuery(lsConnectionString, lsAction, coFbSqlParametersArrayList)
                End If  


                ' display data
                If (liRecordsAffected > 0) Then
                  loDataColumn = New DataColumn("RECORDS AFFECTED")
                  loDataColumn.DataType = System.Type.GetType("System.String")
                  loDataColumn.ReadOnly = True

                  loDataTable.Columns.Add(loDataColumn)

                  loDataRow = loDataTable.NewRow()
                  loDataRow(0) = liRecordsAffected.ToString().Trim()

                  loDataTable.Rows.Add(loDataRow)

                  loDataSet.Tables.Add(loDataTable)    

                  dgReturnedDataResults.ItemsSource = loDataSet.Tables(0).DefaultView()
                Else
                  Display_Message("I", "No data affected by action; but output parameters may have data.") 
                End If

                ' display any output parameter data
                If (coFbSqlParametersArrayList.Count > 0) Then
                    Load_OutputParameterValues(True, coFbSqlParametersArrayList)
                End If  

                Display_Message("I", "Action completed successfully.") 
            Catch loException As Exception
                Display_Message("E", loException.Message) 
            End Try
        End Sub


        Private Sub Execute_MultiActionTransaction()

            Dim liRecordsAffected                As Integer = 0
            Dim lsConnectionString               As String = ""

            Dim loFbSqlParametersArrayList       As New ArrayList()

            Dim loFbSqlHelperTransactionControl  As New BlackFalconAB.Firebird.FbSqlHelperTransactionControl()


            ' ---
            ' ensure that transaction actions array list has action objects
            ' ---
            If (coFbSqlActionsArrayList.Count = 0) Then
                Display_Message("E", "No actions for transaction found !") 
                Return
            End If

            ' ---
            ' get connection string
            ' ---
            lsConnectionString = txtConnectionString.Text.Trim()

            ' ---
            ' perform transaction and return any output parameter data
            ' ---
            coFbSqlConnection = Nothing
            coFbSqlTransaction = Nothing


            For Each loFbSqlHelperActionStructure As BlackFalconAB.Firebird.FbSqlHelperActionStructure In coFbSqlActionsArrayList

                Try
                    liRecordsAffected = loFbSqlHelperTransactionControl.Execute_TransactionUpdate(lsConnectionString, _
                                                                                                loFbSqlHelperActionStructure.FBSQL_ACTION, _
                                                                                                loFbSqlHelperActionStructure.FBSQL_PARAMETERS,
                                                                                                coFbSqlConnection,
                                                                                                coFbSqlTransaction)

                    ' display any output parameter data
                    loFbSqlParametersArrayList = DirectCast(loFbSqlHelperActionStructure.FBSQL_PARAMETERS, ArrayList)

                    If (loFbSqlParametersArrayList.Count > 0) Then
                        Load_OutputParameterValues(False, loFbSqlParametersArrayList)
                    End If  
                Catch loException As Exception
                    Display_Message("E", loException.Message) 
                End Try
            Next


            Try
                loFbSqlHelperTransactionControl.Execute_TransactionCommit(coFbSqlConnection, coFbSqlTransaction)
            Catch loException As Exception
                Display_Message("E", loException.Message) 
            End Try
        End Sub

    #End Region


    #Region "Private Methods - Validations"

        Private Function Is_ValidateExecuteRequirementsOK(e As RoutedEventArgs) As Boolean

            If (csProcess.Trim().Length = 0) Then
                Cursor = Cursors.Arrow
                e.Handled = True    ' image used as button requires event process to be indicated as completed

                Display_Message("E", "No process has been selected !") 
                Return (False)
            End If

            If (txtConnectionString.Text.Trim().Length = 0) Then
                Cursor = Cursors.Arrow
                e.Handled = True    ' image used as button requires event process to be indicated as completed

                Display_Message("E", "No connection string has been selected !") 
                Return (False)
            End If

            If (Not Is_DatabaseConnectionStringOK(txtConnectionString.Text.Trim())) Then
                Cursor = Cursors.Arrow
                e.Handled = True    ' image used as button requires event process to be indicated as completed

                Display_Message("E", "Connection string not valid or database not available !") 
                Return (False)
            End If

            Return (True)
        End Function


        Private Function Is_DatabaseConnectionStringOK(ByVal psConnectionString As String) As Boolean

            Dim loFbSqlHelper  As New BlackFalconAB.Firebird.FbSqlHelper()

            
            Try
                loFbSqlHelper.Test_DatabaseConnection(psConnectionString)
            Catch loException As Exception
                Return (False)
            End Try

            Return (True)
        End Function


        Private Function Validate_FbSqlParameterEntries(ByRef poFbSqlHelperParameterStructure As BlackFalconAB.Firebird.FbSqlHelperParameterStructure, _
                                                        ByRef psSuccessMessage As String) As Boolean

            Dim liSqlParameterSize                     As Integer = 0

            Dim loFbSqlParameterDirectionComboBoxItem  As ComboBoxItem
            Dim loFbSqlDataTypeComboBoxItem            As ComboBoxItem


            Clear_Message()


            loFbSqlParameterDirectionComboBoxItem = lstFbSqlParameterDirections.SelectedItem
            loFbSqlDataTypeComboBoxItem = lstFbSqlDataTypes.SelectedItem


            ' ---
            ' validate parameter entries
            ' ---
            If (txtFbSqlScript.Text.Trim().Length = 0) Then
                Display_Message("E", "Cannot add a parameter without inline sql or stored-procedure name...") 
                Return (False)
            End If

            If (txtFbSqlParameterName.Text.Trim().Length = 0) Then
                Display_Message("E", "Parameter requires a name...") 
                Return (False)
            End If

            If (lstFbSqlParameterDirections.SelectedIndex = 0) Then
                Display_Message("E", "Parameter requires a direction...") 
                Return (False)
            End If

            If (csProcess.Equals("DataReader")) Then
                If (loFbSqlParameterDirectionComboBoxItem.Content.Equals("Output")) Then
                    Display_Message("E", "DataReader query cannot have a parameter direction-type of 'Output' applied to it...") 
                    Return (False)
                End If
            End If

            If (lstFbSqlDataTypes.SelectedIndex = 0) Then
                Display_Message("E", "Parameter requires a data-type...") 
                Return (False)
            End If


            If (loFbSqlParameterDirectionComboBoxItem.Content.Equals("Input")) Then
                If (txtFbSqlParameterValue.Text.Trim().Length = 0) Then
                    Display_Message("E", "Parameter (direction=input) requires a value...") 
                    Return (False)
                End If
            End If

            If (loFbSqlParameterDirectionComboBoxItem.Content.Equals("Input")) Then
                If (Is_ParameterCategoryString(Convert.ToInt32(loFbSqlDataTypeComboBoxItem.Tag.ToString().Trim()))) Then
                    If (txtFbSqlParameterSize.Text.Trim().Length = 0) Then
                        Display_Message("E", "Parameter (category=string) requires a size...") 
                        Return (False)
                    Else
                        Try
                            liSqlParameterSize = Convert.ToInt32(txtFbSqlParameterSize.Text.Trim())
                        Catch loException As Exception
                            Display_Message("E", "Parameter size not numeric...") 
                            Return (False)
                        End Try
                    End If
                End If
            End If

            'If (loFbSqlParameterDirectionComboBoxItem.Content.Equals("Output")) Then
            '    If (Is_ParameterCategoryString(Convert.ToInt32(loFbSqlDataTypeComboBoxItem.Tag.ToString().Trim()))) Then
            '        If (txtFbSqlParameterSize.Text.Trim().Length = 0) Then
            '            Display_Message("E", "Parameter (category=string) requires a size...") 
            '            Return (False)
            '        Else
            '            Try
            '                liSqlParameterSize = Convert.ToInt32(txtFbSqlParameterSize.Text.Trim())
            '            Catch loException As Exception
            '                Display_Message("E", "Parameter size not numeric...") 
            '                Return (False)
            '            End Try
            '        End If
            '    End If
            'End If
                

            For Each loComboBoxItem As ComboBoxItem In lstFbSqlParameterNames.Items
                If (loComboBoxItem.Tag.ToString().Trim().Equals(txtFbSqlParameterName.Text.Trim())) Then
                    psSuccessMessage = "Parameter with the same name has been successfully replaced in parameter list..."
                    Exit For
                End If
            Next


            ' ---
            ' load new parameter structure
            ' ---
            poFbSqlHelperParameterStructure.ACTION_PROCESS = txtFbSqlScript.Text.Trim()
            poFbSqlHelperParameterStructure.PARAMETER_NAME = txtFbSqlParameterName.Text.Trim()

            Select case (loFbSqlParameterDirectionComboBoxItem.Tag.ToString().Trim())
                Case "1":    ' Input
                    poFbSqlHelperParameterStructure.PARAMETER_DIRECTION = System.Data.ParameterDirection.Input

                Case "2":    ' Output
                    poFbSqlHelperParameterStructure.PARAMETER_DIRECTION = System.Data.ParameterDirection.Output
            End Select

            poFbSqlHelperParameterStructure.PARAMETER_FBSQLDBTYPE = Get_SqlParameterFBDBType(lstFbSqlDataTypes.SelectedIndex)

            If (loFbSqlParameterDirectionComboBoxItem.Content.Equals("Input")) Then
                poFbSqlHelperParameterStructure.PARAMETER_VALUE = txtFbSqlParameterValue.Text.Trim()
            Else
                poFbSqlHelperParameterStructure.PARAMETER_VALUE = ""
            End If

            If (Is_ParameterCategoryString(Convert.ToInt32(loFbSqlDataTypeComboBoxItem.Tag.ToString().Trim()))) Then
                poFbSqlHelperParameterStructure.PARAMETER_SIZE = Convert.ToInt32(txtFbSqlParameterSize.Text.Trim())
            Else
                poFbSqlHelperParameterStructure.PARAMETER_SIZE = 0
            End If


            If (psSuccessMessage.Trim().Length = 0) Then
                psSuccessMessage = "Parameter successfully saved in parameter list..."
            End If


            Return (True)
        End Function


        Private Function Is_ParameterCategoryString(ByVal piFbSqlParameterTypeValue As Integer) As Boolean

            For Each loFbSqlDataTypeStructure As FbSqlDataTypeStructure In coFbSqlDataTypesArrayList
                If ((loFbSqlDataTypeStructure.FBSQL_DATA_TYPE_VALUE = piFbSqlParameterTypeValue) And (loFbSqlDataTypeStructure.FBSQL_DATA_TYPE_CATEGORY.ToUpper().Equals("STRING"))) Then
                    Return (True)
                End If
            Next

            Return (False)
        End Function


        Private Function Get_SqlParameterFBDBType(ByVal piSelectedFbSqlDataTypeIndex As Integer) As Integer

            Dim loFbSqlDataTypeStructure  As FbSqlDataTypeStructure


            piSelectedFbSqlDataTypeIndex = piSelectedFbSqlDataTypeIndex - 1

            loFbSqlDataTypeStructure = DirectCast(coFbSqlDataTypesArrayList(piSelectedFbSqlDataTypeIndex), FbSqlDataTypeStructure)

            Return (loFbSqlDataTypeStructure.FBSQL_DATA_TYPE_VALUE)
        End Function


    #End Region


    #Region "Data Manipulation"

        #Region "Data Clears"

            Private Sub Clear_AllClassLevelDeclarations()

                ciFbSqlActionId = 0
                ciSelectedFbSqlActionId = 0
                csProcess = ""
                csXmlString = ""

                coFbSqlParametersArrayList.Clear()
                coFbSqlActionsArrayList.Clear()
            End Sub


            Private Sub Clear_ParameterArrayList()

                coFbSqlParametersArrayList.Clear()
            End Sub    


            Private Sub Clear_FbSqlAndParameterEntries()

                txtFbSqlScript.Text = ""
                txtFbSqlParameterName.Text = ""
                txtFbSqlParameterValue.Text = ""
                txtFbSqlParameterSize.Text = ""

                If (lstFbSqlParameterNames.HasItems) Then
                    lstFbSqlParameterNames.Items.Clear()
                    lstFbSqlParameterNames.IsEnabled = False
                End If
            End Sub

        #End Region


        #Region "Data Loads"

            Private Sub Load_RequiredClassLevelCollections()

                '---
                ' load sql parameter directions array-list (coSQLDirectionsArrayList)
                '---
                coFbSqlDirectionsArrayList.Add(New FbSqlParameterDirectionStructure("Input", 1) )        ' value=1 (System.Data.ParameterDirection.Input)
                coFbSqlDirectionsArrayList.Add(New FbSqlParameterDirectionStructure("Output", 2))        ' value=2 (System.Data.ParameterDirection.Output)
        
                '---
                'load MySql parameter MySql data types array_list (coSQLDataTypesArrayList)
                '
                '  integer equivalents...
                '  ...
                '  FbDbType.Array = 0
                '  FbDbType.BigInt = 1
                '  FbDbType.Binary = 2
                '  FbDbType.Boolean = 3
                '  FbDbType.Char = 4
                '  FbDbType.Date = 5
                '  FbDbType.Decimal = 6    
                '  FbDbType.Double = 7
                '  FbDbType.Float = 8
                '  FbDbType.Guid = 9
                '  FbDbType.Integer = 10
                '  FbDbType.Numeric = 11
                '  FbDbType.SmallInt = 12
                '  FbDbType.Text = 13
                '  FbDbType.Time = 14
                '  FbDbType.TimeStamp = 15
                '  FbDbType.VarChar = 16
                ' ---

                'coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Array", FbDbType.Array, "Binary"))            ' not recommended for use
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("BigInt", FbDbType.BigInt, "Number"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Binary", FbDbType.Binary, "Binary"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Number", FbDbType.Boolean, "Number"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("String", FbDbType.Char, "String"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Date", FbDbType.Date, "Date"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Decimal", FbDbType.Decimal, "Number"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Double", FbDbType.Double, "Number"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Float", FbDbType.Float, "Number"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("UniqueIdentifier", FbDbType.Guid, "GUID"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Integer", FbDbType.Integer, "Number"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Numeric", FbDbType.Numeric, "Number"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("SmallInt", FbDbType.SmallInt, "Number"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Text", FbDbType.Text, "String"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Time", FbDbType.Time, "Time"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("Timestamp", FbDbType.TimeStamp, "Timestamp"))
                coFbSqlDataTypesArrayList.Add(New FbSqlDataTypeStructure("VarChar", FbDbType.VarChar, "String"))
            End Sub


            Private Sub Load_FbSqlParameterArrayList(ByVal poFbSqlHelperParameterStructure As BlackFalconAB.Firebird.FbSqlHelperParameterStructure)

                ' ---
                ' NOTES:
                '   1) add sql parameter structure to class-level array-list 
                '   2) if parameter-name exists in array-list, remove it first
                ' ---

                Dim lboolParameterNameFound  As Boolean = False
                Dim liIndex                  As Integer = 0


                For Each loFbSqlParameter As BlackFalconAB.Firebird.FbSqlHelperParameterStructure In coFbSqlParametersArrayList
                    If (loFbSqlParameter.PARAMETER_NAME.Equals(poFbSqlHelperParameterStructure.PARAMETER_NAME)) Then
                        lboolParameterNameFound = True
                        Exit For
                    End If

                    liIndex = liIndex + 1
                Next

                If (lboolParameterNameFound) Then
                    coFbSqlParametersArrayList.RemoveAt(liIndex) 
                End If

                coFbSqlParametersArrayList.Add(poFbSqlHelperParameterStructure)
            End Sub


            Private Sub Load_FbSqlActionsArrayList(ByVal poFbSQLHelperActionStructure  As BlackFalconAB.Firebird.FbSqlHelperActionStructure)

                ' ---
                ' NOTES:
                '   1) add action structure to class-level array-list 
                '   2) if action exists in array-list, remove it first
                ' ---

                Dim lboolFbSqlActionFound  As Boolean = False
                Dim liIndex                As Integer = 0


                For Each loFbSQLHelperActionStructure As BlackFalconAB.Firebird.FbSqlHelperActionStructure In coFbSqlActionsArrayList
                    If (loFbSQLHelperActionStructure.FBSQL_ACTION_ID =  poFbSQLHelperActionStructure.FBSQL_ACTION_ID) Then
                        lboolFbSqlActionFound = True
                        Exit For
                    End If

                    liIndex = liIndex + 1
                Next

                If (lboolFbSqlActionFound) Then
                    coFbSqlActionsArrayList.Item(liIndex) = poFbSQLHelperActionStructure
                Else
                    ciFbSqlActionId = ciFbSqlActionId + 1
                    poFbSQLHelperActionStructure.FBSQL_ACTION_ID = ciFbSqlActionId
                    coFbSqlActionsArrayList.Add(poFbSQLHelperActionStructure)
                End If
            End Sub

        #End Region


        #Region "Data Deletes"

            Private Sub Delete_FbSqlParameterFromArrayList(ByVal psMySqlParameterName As String)

                Dim lboolParameterNameFound  As Boolean = False
                Dim liIndex                  As Integer = 0


                For Each loFbSqlHelperParameterStructure As BlackFalconAB.Firebird.FbSqlHelperParameterStructure In coFbSqlParametersArrayList
                    If (loFbSqlHelperParameterStructure.PARAMETER_NAME.Equals(psMySqlParameterName.Trim())) Then
                        lboolParameterNameFound = True
                        Exit For
                    End If

                    liIndex = liIndex + 1
                Next

                If (lboolParameterNameFound) Then
                    coFbSqlParametersArrayList.RemoveAt(liIndex) 
                End If
            End Sub


            Private Sub Delete_TransactionActionFromArrayList(ByVal piIndex As Integer)

                Dim liIndex  As Integer = 0


                liIndex = piIndex - 1

                coFbsqlActionsArrayList.RemoveAt(liIndex) 
            End Sub


            Private Sub Delete_AllTransactionActionsFromArrayList()

                ciFbSqlActionId = 0

                coFbSqlActionsArrayList.Clear()
            End Sub


            Private Sub Delete_AllFbSqlParametersFromArrayList()

                coFbSqlParametersArrayList.Clear()
            End Sub

        #End Region

    #End Region


    #Region "Display"

        #Region "Disable Controls"

            Private Sub Disable_AllControls()

                txtFbSqlScript.IsEnabled = False
                txtFbSqlParameterName.IsEnabled = False
                txtFbSqlParameterValue.IsEnabled = False
                txtFbSqlParameterSize.IsEnabled = False

                lstFbSqlParameterNames.IsEnabled = False
                lstFbSqlParameterDirections.IsEnabled = False
                lstFbSqlDataTypes.IsEnabled = False
                lstSavedTransactionActions.IsEnabled = False
                dgReturnedDataResults.IsEnabled = False
                lstvReturnedParameterValues.IsEnabled = False

                btnExecuteSQL.IsEnabled = False
                btnSaveFbSqlParameter.IsEnabled = False
                btnNewFbSqlParameter.IsEnabled = False
                btnDeleteFbSqlParameter.IsEnabled = False
                btnDeleteAllFbSqlParameters.IsEnabled = False
                btnSaveTransactionAction.IsEnabled = False
                btnEditTransactionAction.IsEnabled = False
                btnDeleteTransactionAction.IsEnabled = False
                btnDeleteAllTransactionActions.IsEnabled = False
                btnViewXml.IsEnabled = False
            End Sub

        #End Region


        #Region "Enable Controls"

            Private Sub Enable_DataReaderControls()

                txtFbSqlScript.IsEnabled = True
                txtFbSqlParameterName.IsEnabled = True
                txtFbSqlParameterValue.IsEnabled = True
                txtFbSqlParameterSize.IsEnabled = True

                lstFbSqlParameterDirections.IsEnabled = True
                lstFbSqlDataTypes.IsEnabled = True
                dgReturnedDataResults.IsEnabled = True
                lstvReturnedParameterValues.IsEnabled = True

                btnExecuteSQL.IsEnabled = True
                btnSaveFbSqlParameter.IsEnabled = True
                btnNewFbSqlParameter.IsEnabled = True
                btnDeleteFbSqlParameter.IsEnabled = True
                btnDeleteAllFbSqlParameters.IsEnabled = True
            End Sub


            Private Sub Enable_DataSetControls()

                txtFbSqlScript.IsEnabled = True
                txtFbSqlParameterName.IsEnabled = True
                txtFbSqlParameterValue.IsEnabled = True
                txtFbSqlParameterSize.IsEnabled = True

                lstFbSqlParameterDirections.IsEnabled = True
                lstFbSqlDataTypes.IsEnabled = True
                dgReturnedDataResults.IsEnabled = True
                lstvReturnedParameterValues.IsEnabled = True

                btnExecuteSQL.IsEnabled = True
                btnSaveFbSqlParameter.IsEnabled = True
                btnNewFbSqlParameter.IsEnabled = True
                btnDeleteFbSqlParameter.IsEnabled = True
                btnDeleteAllFbSqlParameters.IsEnabled = True
            End Sub


            Private Sub Enable_XmlControls()

                txtFbSqlScript.IsEnabled = True
                txtFbSqlParameterName.IsEnabled = True
                txtFbSqlParameterValue.IsEnabled = True
                txtFbSqlParameterSize.IsEnabled = True

                lstFbSqlParameterDirections.IsEnabled = True
                lstFbSqlDataTypes.IsEnabled = True
                dgReturnedDataResults.IsEnabled = True
                lstvReturnedParameterValues.IsEnabled = True

                btnExecuteSQL.IsEnabled = True
                btnSaveFbSqlParameter.IsEnabled = True
                btnNewFbSqlParameter.IsEnabled = True
                btnDeleteFbSqlParameter.IsEnabled = True
                btnDeleteAllFbSqlParameters.IsEnabled = True

                btnViewXml.IsEnabled = True
            End Sub


            Private Sub Enable_ScalarControls()

                txtFbSqlScript.IsEnabled = True
                txtFbSqlParameterName.IsEnabled = True
                txtFbSqlParameterValue.IsEnabled = True
                txtFbSqlParameterSize.IsEnabled = True

                lstFbSqlParameterDirections.IsEnabled = True
                lstFbSqlDataTypes.IsEnabled = True
                dgReturnedDataResults.IsEnabled = True
                lstvReturnedParameterValues.IsEnabled = True

                btnExecuteSQL.IsEnabled = True
                btnSaveFbSqlParameter.IsEnabled = True
                btnNewFbSqlParameter.IsEnabled = True
                btnDeleteFbSqlParameter.IsEnabled = True
                btnDeleteAllFbSqlParameters.IsEnabled = True
            End Sub


            Private Sub Enable_UpdateControls()

                txtFbSqlScript.IsEnabled = True
                txtFbSqlParameterName.IsEnabled = True
                txtFbSqlParameterValue.IsEnabled = True
                txtFbSqlParameterSize.IsEnabled = True

                lstFbSqlParameterDirections.IsEnabled = True
                lstFbSqlDataTypes.IsEnabled = True
                dgReturnedDataResults.IsEnabled = True
                lstvReturnedParameterValues.IsEnabled = True

                btnExecuteSQL.IsEnabled = True
                btnSaveFbSqlParameter.IsEnabled = True
                btnNewFbSqlParameter.IsEnabled = True
                btnDeleteFbSqlParameter.IsEnabled = True
                btnDeleteAllFbSqlParameters.IsEnabled = True
            End Sub


            Private Sub Enable_MultiActionTransactionControls()

                txtFbSqlScript.IsEnabled = True
                txtFbSqlParameterName.IsEnabled = True
                txtFbSqlParameterValue.IsEnabled = True
                txtFbSqlParameterSize.IsEnabled = True

                lstFbSqlParameterDirections.IsEnabled = True
                lstFbSqlDataTypes.IsEnabled = True
                dgReturnedDataResults.IsEnabled = True
                lstvReturnedParameterValues.IsEnabled = True

                btnExecuteSQL.IsEnabled = True
                btnSaveFbSqlParameter.IsEnabled = True
                btnNewFbSqlParameter.IsEnabled = True
                btnDeleteFbSqlParameter.IsEnabled = True
                btnDeleteAllFbSqlParameters.IsEnabled = True


                lstSavedTransactionActions.IsEnabled = False

                btnSaveTransactionAction.IsEnabled = True
                btnEditTransactionAction.IsEnabled = True
                btnDeleteTransactionAction.IsEnabled = True
                btnDeleteAllTransactionActions.IsEnabled = True
            End Sub

        #End Region


        #Region "Control Clears"

            Private Sub Clear_AllControls()

                lblSelectedProcess.Content = ""
                lblMessage.Content = ""

                txtFbSqlScript.Text = ""
                txtFbSqlParameterName.Text = ""
                txtFbSqlParameterValue.Text = ""
                txtFbSqlParameterSize.Text = ""

                If (lstFbSqlParameterNames.HasItems) Then
                    lstFbSqlParameterNames.Items.Clear()
                End If

                If (lstSavedTransactionActions.HasItems) Then
                    lstSavedTransactionActions.Items.Clear()
                End If

                If (dgReturnedDataResults.HasItems) Then
                    dgReturnedDataResults.ItemsSource = Nothing
                    dgReturnedDataResults.Items.Clear()
                End If

                If (lstvReturnedParameterValues.HasItems) Then
                    lstvReturnedParameterValues.ItemsSource = Nothing
                    lstvReturnedParameterValues.Items.Clear()
                End If
            End Sub


            Private Sub Clear_ReturnedDataResultsDatagrid()

                dgReturnedDataResults.ItemsSource = Nothing
                dgReturnedDataResults.Items.Clear()
            End Sub


            Private Sub Clear_ReturnedParameterValuesListview()

                lstvReturnedParameterValues.Items.Clear()
                lstvReturnedParameterValues.ItemsSource = Nothing
            End Sub


            Private Sub Clear_ParameterEntries()

                lstFbSqlParameterNames.SelectedIndex = 0

                txtFbSqlParameterName.Text = ""

                lstFbSqlParameterDirections.SelectedIndex = 0
                lstFbSqlDataTypes.SelectedIndex = 0

                txtFbSqlParameterValue.Text = ""
                txtFbSqlParameterSize.Text = ""
            End Sub


            Private Sub Clear_FbSqlParameterNamesListBox()

                lstFbSqlParameterNames.Items.Clear()
                lstFbSqlParameterNames.IsEnabled = False
            End Sub

        #End Region


        #Region "Control Loads"

            Private Sub Load_FbSqlParameterDirectionsListBox()

                Dim loComboBoxItem  As ComboBoxItem


                loComboBoxItem = New ComboBoxItem()
                    loComboBoxItem.Content = "--- Select ---"
                    loComboBoxItem.Tag = "0"
                lstFbSqlParameterDirections.Items.Add(loComboBoxItem)


                For Each loFbSqlParameterDirectionStructure As FbSqlParameterDirectionStructure In coFbSqlDirectionsArrayList
                    loComboBoxItem = New ComboBoxItem()
                        loComboBoxItem.Content = loFbSqlParameterDirectionStructure.FBSQL_PARAMETER_DIRECTION_TYPE
                        loComboBoxItem.Tag = loFBSqlParameterDirectionStructure.FBSQL_PARAMETER_DIRECTION_VALUE.ToString().Trim()
                    lstFbSqlParameterDirections.Items.Add(loComboBoxItem)
                Next

                lstFbSqlParameterDirections.SelectedIndex = 0
            End Sub


            Private Sub Load_FbSqlDataTypesListBox()

                Dim loComboBoxItem  As ComboBoxItem


                loComboBoxItem = New ComboBoxItem()
                    loComboBoxItem.Content = "--- Select ---"
                    loComboBoxItem.Tag = "0"
                lstFbSqlDataTypes.Items.Add(loComboBoxItem)


                For Each loFbSqlDataTypeStructure As FbSqlDataTypeStructure In coFbSqlDataTypesArrayList
                    loComboBoxItem = New ComboBoxItem()
                        loComboBoxItem.Content = loFbSqlDataTypeStructure.FBSQL_DATA_TYPE
                        loComboBoxItem.Tag = loFbSqlDataTypeStructure.FBSQL_DATA_TYPE_VALUE.ToString().Trim()
                    lstFbSqlDataTypes.Items.Add(loComboBoxItem)
                Next

                lstFbSqlDataTypes.SelectedIndex = 0
            End Sub


            Private Sub Load_FbSqlParameterNamesListBoxWithAllNames(ByVal poFbSqlParametersArrayList As ArrayList)

                For Each loFbSqlHelperParameterStructure As BlackFalconAB.Firebird.FbSqlHelperParameterStructure In poFbSqlParametersArrayList
                    Load_FbSqlParameterNamesListBox(loFbSqlHelperParameterStructure)
                Next
            End Sub


            Private Sub Load_FbSqlParameterNamesListBox(ByVal poFbSqlHelperParameterStructure As BlackFalconAB.Firebird.FbSqlHelperParameterStructure)

                Dim lboolParameterNameFound  As Boolean = False
                Dim liIndex                  As Integer = 0

                Dim loComboBoxItem           As ComboBoxItem


                If (lstFbSqlParameterNames.Items.Count = 0) Then
                    loComboBoxItem = New ComboBoxItem()
                        loComboBoxItem.Content = "--- Select ---"
                        loComboBoxItem.Tag = "0"
                    lstFbSqlParameterNames.Items.Add(loComboBoxItem)
                End If


                ' determine if parameter already exists in list-box; if so replace it
                For Each loComboBoxItem In lstFbSqlParameterNames.Items
                    If (loComboBoxItem.Tag.ToString().Trim().Equals(poFbSqlHelperParameterStructure.PARAMETER_NAME)) Then
                        lboolParameterNameFound = True
                        Exit For
                    End If

                    liIndex = liIndex + 1
                Next

                If (lboolParameterNameFound) Then
                    lstFbSqlParameterNames.Items.RemoveAt(liIndex)
                End If


                loComboBoxItem = New ComboBoxItem()
                    loComboBoxItem.Content = poFbSqlHelperParameterStructure.PARAMETER_NAME
                    loComboBoxItem.Tag = poFbSqlHelperParameterStructure.PARAMETER_NAME
                lstFbSqlParameterNames.Items.Add(loComboBoxItem)

                lstFbSqlParameterNames.SelectedIndex = 0
                lstFbSqlParameterNames.IsEnabled = True
            End Sub


            Private Sub Load_ParameterEntries(ByVal piIndex As Integer)

                Dim liIndex                          As Integer = 0    

                Dim loFbSqlHelperParameterStructure  As New BlackFalconAB.Firebird.FbSqlHelperParameterStructure()


                Clear_Message()


                ' ---
                ' if "piIndex" equals zero, this method has been called from "Edit_TransactionAction()"
                ' if "piIndex" is greater than zero, this method has been called from "lstSqlParameterNames_SelectionChanged()"
                ' ---
                If (piIndex > 0) Then
                    liIndex = piIndex - 1
                End If

                loFbSqlHelperParameterStructure = DirectCast(coFbSqlParametersArrayList(liIndex), BlackFalconAB.Firebird.FbSqlHelperParameterStructure)


                ' parameter name
                txtFbSqlParameterName.Text = loFbSqlHelperParameterStructure.PARAMETER_NAME


                ' parameter direction (list selection)
                ' parameter direction object must be converted to its represenative, numeric value for comparison
                liIndex = 0

                For Each loComboBoxItem As ComboBoxItem In lstFbSqlParameterDirections.Items
                    If (loComboBoxItem.Tag.ToString().Trim().Equals(Convert.ToInt32(loFbSqlHelperParameterStructure.PARAMETER_DIRECTION).ToString().Trim())) Then
                        lstFbSqlParameterDirections.SelectedIndex = liIndex
                        Exit For
                    End If

                    liIndex = liIndex + 1
                Next


                ' parameter data type (list selection)
                liIndex = 0

                For Each loComboBoxItem As ComboBoxItem In lstFbSqlDataTypes.Items
                    If (DirectCast(Convert.ToInt32(loComboBoxItem.Tag.ToString().Trim()), System.Data.SqlDbType) = loFbSqlHelperParameterStructure.PARAMETER_FBSQLDBTYPE) Then
                        lstFbSqlDataTypes.SelectedIndex = liIndex
                        Exit For
                    End If

                    liIndex = liIndex + 1
                Next


                ' parameter value (if input)
                txtFbSqlParameterValue.Text = loFbSqlHelperParameterStructure.PARAMETER_VALUE


                ' parameter size (if string)
                If (loFbSqlHelperParameterStructure.PARAMETER_SIZE = 0) Then
                    txtFbSqlParameterSize.Text = ""
                Else
                    txtFbSqlParameterSize.Text = loFbSqlHelperParameterStructure.PARAMETER_SIZE.ToString().Trim()
                End If
            End Sub


            Private Sub Load_OutputParameterValues(ByVal pboolClearListView As Boolean, _
                                                   ByVal poFbSqlHelperParameterStructures As ArrayList)

                If (pboolClearListView) Then
                    lstvReturnedParameterValues.ItemsSource = Nothing
                    lstvReturnedParameterValues.Items.Clear()
                End If

                For Each loFbSqlHelperParameterStructure As BlackFalconAB.Firebird.FbSqlHelperParameterStructure In poFbSqlHelperParameterStructures
                    If (loFbSqlHelperParameterStructure.PARAMETER_DIRECTION = ParameterDirection.Output) Then
                        lstvReturnedParameterValues.Items.Add(loFbSqlHelperParameterStructure)
                    End If
                Next
            End Sub


            Private Sub Load_SavedTransactionActionEntriesListbox()

                Dim lboolParameterNameFound     As Boolean = False
                Dim liIndex                     As Integer = 0

                Dim loComboBoxItem              As ComboBoxItem


                lstSavedTransactionActions.Items.Clear()


                loComboBoxItem = New ComboBoxItem()
                    loComboBoxItem.Content = "--- Select ---"
                    loComboBoxItem.Tag = "0"
                lstSavedTransactionActions.Items.Add(loComboBoxItem)


                For Each loFbSqlHelperActionStructure In coFbSqlActionsArrayList
                    loComboBoxItem = New ComboBoxItem()
                        loComboBoxItem.Content = loFbSqlHelperActionStructure.FBSQL_ACTION + "(" + loFbSqlHelperActionStructure.FBSQL_ACTION_ID.ToString().Trim() + ")"
                        loComboBoxItem.Tag = loFbSqlHelperActionStructure.FBSQL_ACTION_ID.ToString().Trim()
                    lstSavedTransactionActions.Items.Add(loComboBoxItem)
                Next

                lstSavedTransactionActions.SelectedIndex = 0
                lstSavedTransactionActions.IsEnabled = True
            End Sub

        #End Region


        #Region "Control Deletes"

            Private Sub Delete_FbSqlParameterFromListBox(ByVal psMySqlParameterName As String)

                Dim lboolParameterNameFound  As Boolean = False
                Dim liIndex                  As Integer = 0


                cboolBypassFbSqlParameterNamesListSelectionChangedEvent = True

                    For Each loComboBoxItem In lstFbSqlParameterNames.Items
                        If (loComboBoxItem.Tag.ToString().Trim().Equals(psMySqlParameterName.Trim())) Then
                            lboolParameterNameFound = True
                            Exit For
                        End If

                        liIndex = liIndex + 1
                    Next

                    If (lboolParameterNameFound) Then
                        lstFbSqlParameterNames.Items.RemoveAt(liIndex)
                    End If


                    ' ---
                    ' if a single item remains in the parameter-names listbox it will be the
                    ' the default "--- Select ---" item; then delete all items and set listbox
                    ' to disabled
                    ' ---
                    If (lstFbSqlParameterNames.Items.Count = 1) Then
                        lstFbSqlParameterNames.Items.Clear()
                        lstFbSqlParameterNames.IsEnabled = False
                    End If

                cboolBypassFbSqlParameterNamesListSelectionChangedEvent = False
            End Sub


            Private Sub Delete_AllFbSqlParameterFromListBox()

                cboolBypassFbSqlParameterNamesListSelectionChangedEvent = True

                    lstFbSqlParameterNames.Items.Clear()
                    lstFbSqlParameterNames.IsEnabled = False

                cboolBypassFbSqlParameterNamesListSelectionChangedEvent = False
            End Sub


            Private Sub Delete_TransactionActionFromListBox(ByVal piIndex As Integer)

                Dim lboolTransactionActionFound  As Boolean = False
                Dim liIndex                      As Integer = 0


                cboolBypassTransactionActionsListSelectionChangedEvent = True

                    lstSavedTransactionActions.Items.RemoveAt(piIndex)


                    ' ---
                    ' if a single item remains in the transaction-actions listbox it will be the
                    ' the default "--- Select ---" item; then delete all items and set listbox
                    ' to disabled
                    ' ---
                    If (lstSavedTransactionActions.Items.Count = 1) Then
                        lstSavedTransactionActions.Items.Clear()
                        lstSavedTransactionActions.IsEnabled = False
                    Else
                        lstSavedTransactionActions.SelectedIndex = 0
                    End If

                cboolBypassTransactionActionsListSelectionChangedEvent = False
            End Sub


            Private Sub Delete_AllTransactionActionsFromListBox()

                lstSavedTransactionActions.Items.Clear()
                lstSavedTransactionActions.IsEnabled = False
            End Sub


        #End Region


        #Region "Messages"

            Private Sub Clear_Message()

                lblMessage.Content = ""
            End Sub


            Private Sub Display_Message(ByVal psMessageType As String, _
                                        ByVal psMessage As String)

                Dim loBrushConverter  As  New BrushConverter()  


                Select Case (psMessageType.ToUpper())
                    Case "E":
                        lblMessage.Foreground = Brushes.Red

                    Case "I":
                        lblMessage.Foreground = Brushes.DarkSlateBlue
                End Select
            
                lblMessage.Content = psMessage
            End Sub

        #End Region
    
    #End Region

End Class
